/*-*- mode:unix-assembly; indent-tabs-mode:t; tab-width:8; coding:utf-8     -*-│
│vi: set et ft=asm ts=8 tw=8 fenc=utf-8                                     :vi│
╞══════════════════════════════════════════════════════════════════════════════╡
│ Copyright 2020 Justine Alexandra Roberts Tunney                              │
│                                                                              │
│ Permission to use, copy, modify, and/or distribute this software for         │
│ any purpose with or without fee is hereby granted, provided that the         │
│ above copyright notice and this permission notice appear in all copies.      │
│                                                                              │
│ THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL                │
│ WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED                │
│ WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE             │
│ AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL         │
│ DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR        │
│ PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER               │
│ TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR             │
│ PERFORMANCE OF THIS SOFTWARE.                                                │
╚─────────────────────────────────────────────────────────────────────────────*/
#include "libc/macros.internal.h"
#include "libc/notice.inc"
.source	__FILE__

//	Allocates aligned memory.
//
//	Returns a pointer to a newly allocated chunk of n bytes, aligned in
//	accord with the alignment argument. The alignment argument should be
//	a power of two. If the argument is not a power of two, the nearest
//	greater power is used. 8-byte alignment is guaranteed by normal
//	malloc calls, so don't bother calling memalign with an argument of 8
//	or less.
//
//	@param	rdi is alignment in bytes
//	@param	rsi (newsize) is number of bytes needed
//	@return	rax is memory address, or NULL w/ errno
//	@note	overreliance on memalign is a sure way to fragment space
//	@see	dlmemalign()
memalign:
	jmp	*hook_memalign(%rip)
	.endfn	memalign,globl
